; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 5.5        *
; *     Interrupt Vector Swapping                       *
; *                                                     *
; *******************************************************

        TITLE   SWAP

        LOCALS  @@

DATA    SEGMENT WORD PUBLIC

        EXTRN   SaveInt00:DWORD
    IFDEF _DPMI
        EXTRN SaveIntTab:WORD
    ELSE
        EXTRN SaveIntTab:BYTE
    ENDIF

DATA    ENDS

CODE    SEGMENT BYTE PUBLIC

        ASSUME  CS:CODE,DS:DATA

        PUBLIC  SwapVectors

    IFDEF _DPMI_

SwapVectors:
        MOV    DI,OFFSET SaveInt00
        MOV    SI,OFFSET SaveIntTab
        cld
        lodsw
        mov cx, ax
        CLD
@@1:    PUSH   CX
         lodsw
         MOV    BL,AH
         MOV    AH,2
         INT    31H
         XCHG   DX,[DI]
         XCHG   CX,[DI+2]
         INC    AX
         INT    31H
        POP     CX
        ADD     DI,4
        LOOP    @@1
        RETF

    ELSE

SwapVectors:
        MOV     DI,OFFSET SaveInt00
        MOV     SI,OFFSET SaveIntTab
        cld
        lodsb
        xor ch, ch
        mov cl, al
@@1:    lodsb
        MOV     AH,35H
        INT     21H
        PUSH    ES
         PUSH   BX
          PUSH  DS
           LDS  DX,[DI]
           MOV  AH,25H
           INT  21H
          POP   DS
         POP    WORD PTR [DI]
        POP     WORD PTR [DI+2]
        ADD     DI,4
        LOOP    @@1
        RETF

    ENDIF

CODE    ENDS

        END
