; *******************************************************
; *                                                     *
; *     Turbo Pascal Run-time Library                   *
; *     Command Line Parameter Routines                 *
; *                                                     *
; *******************************************************

        TITLE   PARS

        INCLUDE SE.ASM

DATA    SEGMENT WORD PUBLIC
        EXTRN PrefixSeg:Word
DATA    ENDS

CODE    SEGMENT BYTE PUBLIC

        ASSUME  CS:CODE,DS:DATA

; Publics
        PUBLIC  ParmStr,ParmCount

ParmStr:ARG     StrP,DWORD,1

        ARG ParPlc,DWORD,1
        ARG     Index,WORD,1

        ENTRY   FAR
        MOV     DX,Index
        OR      DX,DX
        JZ      @@1
        les di, ParPlc
        CALL    ParStrCnt
        JMP     SHORT @@4
@@1:
@@4:    PUSH    DS
        PUSH    ES
        POP     DS
        LES     DI,StrP
        CLD
        STOSB
        XCHG    AX,CX
        REP     MOVSB
        POP     DS
        EXIT    6

ParmCount:

        ARG ParPlc,DWORD,1
        ENTRY FAR
        XOR     DX,DX
        les di, ParPlc
        CALL    ParStrCnt
        XCHG    AX,BX
        EXIT 4

; Return parameter string and count
; In    DX    = Parameter string number
;       ES:SI = Parameter''s address
; Out   AX    = Parameter string length
;       BX    = Parameter string count
;       ES:SI = Parameter string pointer
ParStrCnt:
        MOV     CL,ES:[DI]
        XOR     CH,CH
        INC     DI
        XOR     BX,BX
@@1:    JCXZ    @@3
@@2:    CMP     BYTE PTR ES:[DI],' '    ; Niin kauan kuin tyhj riitt
        JA      @@3
        INC     DI
        LOOP    @@2
@@3:    MOV     SI,DI
        JCXZ    @@5
@@4:    CMP     BYTE PTR ES:[DI],' '
        JBE     @@5
        INC     DI
        LOOP    @@4
@@5:    MOV     AX,DI
        SUB     AX,SI
        JE      @@6
        INC     BX
        DEC     DX
        JNZ     @@1
@@6:    RET

CODE    ENDS

        END
